[BestCoder Round #4] hdu 4932 Miaomiao's Geometry (贪心)

Miaomiao‘s Geometry

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)

Total Submission(s): 363    Accepted Submission(s): 92

Problem Description

There are N point on X-axis . Miaomiao would like to cover them ALL by using segments with same length.

There are 2 limits:

1.A point is convered if there is a segments T , the point is the left end or the right end of T.

2.The length of the intersection of any two segments equals zero.

For example , point 2 is convered by [2 , 4] and not convered by [1 , 3]. [1 , 2] and [2 , 3] are legal segments , [1 , 2] and [3 , 4] are legal segments , but [1 , 3] and [2 , 4] are not (the length of intersection doesn‘t equals zero), [1 , 3] and [3 , 4]
are not(not the same length).

Miaomiao wants to maximum the length of segements , please tell her the maximum length of segments.

For your information , the point can‘t coincidently at the same position.

Input

There are several test cases.

There is a number T ( T <= 50 ) on the first line which shows the number of test cases.

For each test cases , there is a number N ( 3 <= N <= 50 ) on the first line.

On the second line , there are N integers Ai (-1e9 <= Ai <= 1e9) shows the position of each point.

Output

For each test cases , output a real number shows the answser. Please output three digit after the decimal point.

Sample Input

3
3
1 2 3
3
1 2 4
4
1 9 100 10

Sample Output

1.000
2.000
8.000

Hint

For the first sample , a legal answer is [1,2] [2,3] so the length is 1.
For the second sample , a legal answer is [-1,1] [2,4] so the answer is 2.
For the thired sample , a legal answer is [-7,1] , [1,9] , [10,18] , [100,108] so the answer is 8.

Source

BestCoder Round #4

解题思路:

比赛时用二分做的,后来被hack掉了。。

二分结果不对:比如下面这组数据:

4

0 1 4 5

所有可能的线段长度最大可能有两种情况(某两个相邻点之间的距离,某两个相邻点之间的距离的一半)。为什么说是最大,比两个相邻点之间的距离一半小当然没问题。

所以我们就把所有相邻的点之间的区间距离以及它的一半保存在数组里面,从小到大排序,逆向遍历,每遍历一个数判断是否符合题意,如果符合,就退出,得到了答案。怎么判断是否符合题意呢?

用到了贪心的思想,能放左边,放左边,不能放左边,放右边。

注意到本题并没有对线段的多少有限制,只要求线段的最大长度,我觉得这个条件对贪心起着关键作用。

代码:

#include <iostream>
#include <stdio.h>
#include <string.h>
#include <queue>
#include <stack>
#include <algorithm>
#include <cmath>
#include <iomanip>
using namespace std;
int num[60];
double inter[120];//区间,里面保留着相邻两个点的区间距离以及区间距离的一半
const int eps=1e-6;
int n;

bool ok(double l)
{
    double temp=num[1];
    for(int i=2;i<=n-1;i++)
    {
        if(temp==num[i])//当倒数第二个点正好被覆盖时,不用计算后面tep=num[i]+l  if(temp>num[i+1])  最后那个点是自由的
            continue;
        if(num[i]-l>=temp)
            temp=num[i];
        else
        {
            temp=num[i]+l;
            if(temp>num[i+1])
                return false;
        }
    }
    return true;
}

int main()
{
    int t;cin>>t;
    while(t--)
    {
        scanf("%d",&n);
        for(int i=1;i<=n;i++)
            scanf("%d",&num[i]);
        sort(num+1,num+1+n);
        int cnt=0;
        for(int i=1;i<=n;i++)
        {
            inter[cnt++]=num[i]-num[i-1];
            inter[cnt++]=(num[i]-num[i-1])/2.0;
        }
        sort(inter,inter+cnt);
        double ans=0;
        for(int i=cnt-1;i>=0;i--)
        {
            if(ok(inter[i]))
            {
                ans=inter[i];
                break;
            }
        }
        cout<<setiosflags(ios::fixed)<<setprecision(3)<<ans<<endl;
    }
    return 0;
}

[BestCoder Round #4] hdu 4932 Miaomiao's Geometry (贪心)

时间: 2024-08-06 03:45:42

[BestCoder Round #4] hdu 4932 Miaomiao's Geometry (贪心)的相关文章

HDU 4932 Miaomiao&#39;s Geometry(BestCoder Round #4)

Problem Description: There are N point on X-axis . Miaomiao would like to cover them ALL by using segments with same length. There are 2 limits: 1.A point is convered if there is a segments T , the point is the left end or the right end of T.2.The le

hdu 4932 Miaomiao&#39;s Geometry 解题报告

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4932 题目意思:给出 n 个点你,需要找出最长的线段来覆盖所有的点.这个最长线段需要满足两个条件:(1)每个点是某条线段的左端点或右端点   (2)任意两条线段之间的重叠部分的长度为0.(一个点重叠默认长度为0,即[1,2] , [2, 3] 视为合法).还有一点我来补充吧,就是这个最大长度是固定的,看第3组测试数据  1 9 100 10,[-7,1] , [1,9] , [10,18] , [1

hdu 4932 Miaomiao&#39;s Geometry(暴力)

题目链接:hdu 4932 Miaomiao's Geometry 题目大意:在x坐标上又若干个点,现在要用若干条相等长度的线段覆盖这些点,若一个点被一条线段覆盖,则必须在这条线的左端点或者是右端点,并且各个线段放的位置不能又重叠,求最大长度. 解题思路:这题有坑点,比赛的时候o(n)的算法去寻找两点之间最短距离.但起始这样是不行的,比如-1 0 10 12 18 20,这样维护过去的话,最短应该是12~18,长度为6,这段线段可以覆盖12和18的点,然后-1和20又在两端.于是只有0和10两点

HDU 4932 Miaomiao&#39;s Geometry(推理)

HDU 4932 Miaomiao's Geometry 题目链接 题意:给定x轴上一些点(不重复),现在要选一个线段,使得能放进这些区间中,保证线段不跨过点(即线段上只能是最左边或最右边是点),并且没有线段相交,求能放进去的最大线段 思路:推理一下,只有两点之间的线段,还有线段的一半可能符合题意,然后对于每种线段,去判断一下能不能成功放进去,这步用贪心,优先放左边,不行再放右边 代码: #include <cstdio> #include <cstring> #include &

hdu 4932 Miaomiao&#39;s Geometry 暴力枚举

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4932 Miaomiao's Geometry Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 694    Accepted Submission(s): 180 Problem Description There are N point

hdu 4932 Miaomiao&#39;s Geometry(暴力枚举)

Miaomiao's Geometry                                                                              Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Problem Description There are N point on X-axis . Miaomiao would like

HDU 4932 Miaomiao&#39;s Geometry

答案只可能有两种情况 要么是已知点的距离 要么是已知点距离的一半 那么就枚举每个点之间的距离 和距离的一半 先把所有点按照升序排序 然后用枚举的值贪心 对于点A[i] 如果能放[[A[i]-now,A[i]]就放 否则就放[A[i],A[i]+now] #include<bits/stdc++.h> using namespace std; double a[120],b[120]; int main() { int T,N; scanf("%d",&T); for

hdu 4932 Miaomiao&amp;#39;s Geometry(暴力枚举)

Miaomiao's Geometry                                                                              Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Problem Description There are N point on X-axis . Miaomiao would like

Bestcoder round #65 &amp;&amp; hdu 5592 ZYB&#39;s Premutation 线段树

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 175    Accepted Submission(s): 74 Problem Description ZYB has a premutation P,but he only remeber the reverse log of each prefix of the premutat